<template>
  <div v-if="editMode" :class="{ 'editable-field': true, 'alted': isAltPressed }">
    <!-- <pre>{{ config.options }}</pre> -->
    <!-- <div contenteditable="true" @input="update">{{ textfieldEditedData }}</div> -->
    <check-na :field="textareaRawData"><inline-editor v-model="textareaRawData" type="multi" :read-only="config.read_only" :placeholder="textareaPlaceholder"></inline-editor></check-na>
  </div>
  <div v-else-if="textareaData">
    <div v-if="displayAsHTML" v-html="textareaData"></div>
    <div v-else>
      {{ textareaData }}
    </div>
  </div>
  <div v-else>
    <slot></slot>
  </div>
</template>

<script>
import _ from 'lodash'

import { mapActions, mapGetters } from 'vuex'

import InlineEditor from '@/components/Editable/Utils/InlineEditor'
import CheckNa from '@/components/Editable/Utils/CheckNa'

export default {
  components: {
    InlineEditor,
    CheckNa
  },

  props: {
    node: {
      type: Object,
      required: true
    },
    path: {
      type: Array,
      required: true
    }
    // options: {
    //   type: Object,
    //   required: false
    // }
  },

  data () {
    return {
    }
  },

  computed: {
    ...mapGetters({
      getEditedField: 'Y3TI/getEditedField',
      editMode: 'Y3TI/editMode',
      getFieldConfig: 'Y3TI/getFieldConfig',
      isAltPressed: 'Y3TI/isAltPressed'
    }),

    config () {
      return this.getFieldConfig({ node: this.node, path: this.path })
    },

    textareaPlaceholder () {
      return _.get(this.config, 'widget.form.settings.placeholder')
    },

    displayAsHTML () {
      return _.get(this.config, 'options.display_as_html', false)
    },

    textareaData () {
      return _.get(this.node, this.path)
    },

    textareaRawData: {
      get () {
        // return _.get(this.$store.state.app.edited, this.editablePath)
        return this.getEditedField({ node: this.node, path: this.path })
      },
      set (value) {
        this.storeEditableFieldData({ data: { node: this.node, path: this.path, input: value } })
      }
    }
  },

  methods: {
    ...mapActions({
      storeEditableFieldData: 'Y3TI/storeEditableFieldData'
    }),

    update (e) {
      this.storeEditableFieldData({ data: { node: this.node, path: this.path, input: e.target.innerHTML } })
    }
  }
}
</script>

<style lang="scss" scoped>
</style>
